
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Job_mediaDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_media = await db.job_media.create(
            {
                id: data.id || undefined,
        
        media_type: data.media_type
        ||
        null
            ,
            
        caption: data.caption
        ||
        null
            ,
            
        uploaded_at: data.uploaded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await job_media.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await job_media.setJob( data.job || null, {
            transaction,
        });
        
        await job_media.setUploaded_by( data.uploaded_by || null, {
            transaction,
        });
        
        await job_media.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.job_media.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: job_media.id,
            },
            data.photos,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.job_media.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: job_media.id,
            },
            data.attachments,
            options,
        );
        

        return job_media;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const job_mediaData = data.map((item, index) => ({
                id: item.id || undefined,
                
                media_type: item.media_type
            ||
            null
            ,
            
                caption: item.caption
            ||
            null
            ,
            
                uploaded_at: item.uploaded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const job_media = await db.job_media.bulkCreate(job_mediaData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < job_media.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.job_media.getTableName(),
                    belongsToColumn: 'photos',
                    belongsToId: job_media[i].id,
                },
                data[i].photos,
                options,
            );
        }
        
        for (let i = 0; i < job_media.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.job_media.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: job_media[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return job_media;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const job_media = await db.job_media.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.media_type !== undefined) updatePayload.media_type = data.media_type;
        
        
        if (data.caption !== undefined) updatePayload.caption = data.caption;
        
        
        if (data.uploaded_at !== undefined) updatePayload.uploaded_at = data.uploaded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await job_media.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await job_media.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.job !== undefined) {
            await job_media.setJob(
              
              data.job,
              
              { transaction }
            );
        }
        
        if (data.uploaded_by !== undefined) {
            await job_media.setUploaded_by(
              
              data.uploaded_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await job_media.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.job_media.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: job_media.id,
            },
            data.photos,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.job_media.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: job_media.id,
            },
            data.attachments,
            options,
        );
        

        return job_media;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_media = await db.job_media.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of job_media) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of job_media) {
                await record.destroy({transaction});
            }
        });


        return job_media;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const job_media = await db.job_media.findByPk(id, options);

        await job_media.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await job_media.destroy({
            transaction
        });

        return job_media;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const job_media = await db.job_media.findOne(
            { where },
            { transaction },
        );

        if (!job_media) {
            return job_media;
        }

        const output = job_media.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await job_media.getWorkspace({
            transaction
        });
        
        
        output.job = await job_media.getJob({
            transaction
        });
        
        
        output.photos = await job_media.getPhotos({
            transaction
        });
        
        
        output.attachments = await job_media.getAttachments({
            transaction
        });
        
        
        output.uploaded_by = await job_media.getUploaded_by({
            transaction
        });
        
        
        output.organizations = await job_media.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.jobs,
        as: 'job',
        
        where: filter.job ? {
          [Op.or]: [
            { id: { [Op.in]: filter.job.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.job.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'uploaded_by',
        
        where: filter.uploaded_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uploaded_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.uploaded_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'photos',
      },

      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.caption) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_media',
                        'caption',
                        filter.caption,
                    ),
                };
            }
            

            
            

            
            if (filter.uploaded_atRange) {
                const [start, end] = filter.uploaded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.media_type) {
                where = {
                    ...where,
                media_type: filter.media_type,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.job_media.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'job_media',
                        'caption',
                        query,
                    ),
                ],
            };
        }

        const records = await db.job_media.findAll({
            attributes: [ 'id', 'caption' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['caption', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.caption,
        }));
    }

    
};

